C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C                                                                  
C The ODE Function of Chemical Model File                          
C                                                                  
C Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor  
C       (http://www.cs.vt.edu/~asandu/Software/KPP)                
C KPP is distributed under GPL, the general public licence         
C       (http://www.gnu.org/copyleft/gpl.html)                     
C (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa           
C (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech            
C     With important contributions from:                           
C        M. Damian, Villanova University, USA                      
C        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
C                                                                  
C File                 : chem_hg_Function.f                        
C Time                 : Thu Mar 27 11:36:36 2014                  
C Working directory    : /n/home05/yxzhang/kpp/kpp-2.2.3/mehg      
C Equation file        : chem_hg.kpp                               
C Output root filename : chem_hg                                   
C                                                                  
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C                                                                  
C Fun - time derivatives of variables - Agregate form              
C   Arguments :                                                    
C      V         - Concentrations of variable species (local)      
C      F         - Concentrations of fixed species (local)         
C      RCT       - Rate constants (local)                          
C      Vdot      - Time derivative of variable species concentrations
C                                                                  
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      SUBROUTINE Fun ( V, F, RCT, Vdot )

      IMPLICIT NONE
      INCLUDE 'chem_hg_Parameters.h'

C V - Concentrations of variable species (local)                   
      REAL*8 V(NVAR)
C F - Concentrations of fixed species (local)                      
      REAL*8 F(NFIX)
C RCT - Rate constants (local)                                     
      REAL*8 RCT(NREACT)
C Vdot - Time derivative of variable species concentrations        
      REAL*8 Vdot(NVAR)


C Local variables                                                  
C A - Rate for each equation                                       
      REAL*8 A(NREACT)

C Computation of equation rates                                    
      A(1) = RCT(1)*V(13)
      A(2) = RCT(2)*V(13)
      A(3) = RCT(3)*V(14)
      A(4) = RCT(4)*V(14)
      A(5) = RCT(5)*V(13)
      A(6) = RCT(6)*V(14)
      A(7) = RCT(7)*V(12)
      A(8) = RCT(8)*V(12)
      A(9) = RCT(9)*V(12)
      A(10) = RCT(10)*V(11)

C Aggregate function                                               
      Vdot(1) = A(1)
      Vdot(2) = A(2)
      Vdot(3) = A(3)
      Vdot(4) = A(4)
      Vdot(5) = A(5)
      Vdot(6) = A(6)
      Vdot(7) = A(7)
      Vdot(8) = A(8)
      Vdot(9) = A(9)
      Vdot(10) = A(10)
      Vdot(11) = A(9)-A(10)
      Vdot(12) = A(6)-A(7)-A(8)-A(9)+A(10)
      Vdot(13) = -A(1)-A(2)+A(3)+A(4)-A(5)+A(7)
      Vdot(14) = A(1)+A(2)-A(3)-A(4)+A(5)-A(6)+A(8)
      RETURN
      END

C End of Fun function                                              
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


